﻿MorgBid2 = LibStub("AceAddon-3.0"):NewAddon("MorgBid2", "AceComm-3.0", "AceConsole-3.0", "AceSerializer-3.0")
local media = LibStub("LibSharedMedia-3.0", true)
local C = LibStub("AceConfigDialog-3.0")
local CC = LibStub("AceConfigCmd-3.0")

--locals
local L = LibStub("AceLocale-3.0"):NewLocale("MorgBid2", "enUS", true)
	
if L then
	L[" points"] = true
	L["All frames"] = true
	L["Allows you to position where tooltips will appear for DKP."] = true
	L["Background color"] = true
	L["Background texture"] = true
	L["Bidding tooltip options"] = true
	L["Border color"] = true
	L["Border texture"] = true
	L["Disables the tooltip hints."] = true
	L["Font size"] = true
	L["Font"] = true
	L["General options"] = true
	L["Hide hints"] = true
	L["%s DKP"] = true
	L["Maximum number of lines before creating a scrollframe."] = true
	L["MorgBid2"] = true
	L["Mousewheel up/Left Click - Increase bid.\nMousewheel down/Right Click - decrease bid.\nSHIFT-KEY - change bid by +/-1\nALT-KEY - change bid by +/-20"] = true
	L["NEED"] = true
	L["Need.\nUse this option if you want this item."] = true
	L["NONE"] = true
	L["PASS"] = true
	L["Pass.\nUse this option if you do not need this item"] = true
	L["Receiving DKP data..."] = true
	L["Reset default frame positions."] = true
	L["Reset frames"] = true
	L["Result Font"] = true
	L["Result fontsize"] = true
	L["Result Frame options"] = true
	L["Result lines"] = true
	L["Result Tooltip"] = true
	L["Shows the DKP listing of the current item after the auction ends."] = true
	L["TAKE"] = true
	L["Take.\nUse this option if you are able to take this\nitem, but do not necessarily want it or\nwould prefer someone else take it first.\nAlternatively use this button if this is an\noff-spec item (for example dps gear for\nhealers) \nor you have ALREADY received loot.\nBidWar mode use this button to place bid."] = true
	L["Toggle Tooltip anchor"] = true
	L["Use result tooltip"] = true
end

local L = LibStub("AceLocale-3.0"):NewLocale("MorgBid2", "deDE", true)
	
if L then
	--need loc
	L["All frames"] = true
	L["Allows you to position where tooltips will appear for DKP."] = true
	L["Background color"] = true
	L["Background texture"] = true
	L["Bidding tooltip options"] = true
	L["Border color"] = true
	L["Border texture"] = true
	L["Disables the tooltip hints."] = true
	L["Font size"] = true
	L["Font"] = true
	L["General options"] = true
	L["Hide hints"] = true
	L["%s DKP"] = true
	L["Maximum number of lines before creating a scrollframe."] = true
	L["MorgBid2"] = true
	L["NEED"] = true
	L["NONE"] = true
	L["PASS"] = true
	L["Receiving DKP data..."] = true
	L["Reset default frame positions."] = true
	L["Reset frames"] = true
	L["Result Font"] = true
	L["Result fontsize"] = true
	L["Result Frame options"] = true
	L["Result lines"] = true
	L["Result Tooltip"] = true
	L["Shows the DKP listing of the current item after the auction ends."] = true
	L["TAKE"] = true
	L["Toggle Tooltip anchor"] = true
	L["Use result tooltip"] = true
	
	L[" points"] = " Punkte"
	L["Need.\nUse this option if you want this item."] = "Bedarf.\nBenutze diese Option wenn du das Item willst."
	L["Mousewheel up/Left Click - Increase bid.\nMousewheel down/Right Click - decrease bid.\nSHIFT-KEY - change bid by +/-1\nALT-KEY - change bid by +/-20"] = "Mausrad hoch/Linksklick - Gebot erh/195/182hen.\nMausrad runter/Rechtsklick - Gebot verringern.\nSHIFT-Taste - Gebot /195/164ndern um +/-1\nALT-Taste - Gebot /195/164ndern um +/-20"
	L["Take.\nUse this option if you are able to take this\nitem, but do not necessarily want it or\nwould prefer someone else take it first.\nAlternatively use this button if this is an\noff-spec item (for example dps gear for\nhealers) \nor you have ALREADY received loot.\nBidWar mode use this button to place bid."] = "Nehmen.\nBenutze diese Option, wenn du das Item\nnehmen kannst, aber es nicht unbedingt willst\noder jemand Anderem den Vorzug geben willst.\nNutze diese Option alternativ, wenn das ein Zweititem ist\n(z.B. dps-Gear f/195/188r Heiler) oder wenn du\nin diesem Raid bereits Loot erhalten hast.\nBidWar Modus: Benutze diese Option um dein Gebot abzugeben."
	L["Pass.\nUse this option if you do not need this item"] = "Passen.\nBenutze diese Option, wenn du das Item nicht brauchst."
end

local L = LibStub("AceLocale-3.0"):NewLocale("MorgBid2", "ruRU", true)
	
if L then
	L["All frames"] = "Все окна"
	L["Allows you to position where tooltips will appear for DKP."] = true
	L["Background color"] = "Цвет фона"
	L["Background texture"] = "Текстура фона"
	L["Bidding tooltip options"] = "Настройки окна стоимости\предложения"
	L["Border color"] = "Цвет границ"
	L["Border texture"] = "Текстура границ"
	L["Disables the tooltip hints."] = "Отключить окна подсказок."
	L["Font size"] = true
	L["Font"] = "Шрифт"
	L["General options"] = true
	L["Hide hints"] = "Скрыть подсказки"
	L["%s DKP"] = true
	L["Maximum number of lines before creating a scrollframe."] = true
	L["NEED"] = "Нужен"
	L["NONE"] = true
	L["PASS"] = "Пас"
	L["Receiving DKP data..."] = "Получение данных DKP..."
	L["Reset default frame positions."] = "Установить по умолчанию настройки расположения окна."
	L["Reset frames"] = true
	L["Result Font"] = true
	L["Result fontsize"] = true
	L["Result Frame options"] = true
	L["Result lines"] = true
	L["Result Tooltip"] = true
	L["Shows the DKP listing of the current item after the auction ends."] = true
	L["TAKE"] = "Возьму"
	L["Toggle Tooltip anchor"] = true
	L["Use result tooltip"] = true
	
	L[" points"] = " очков"
	L["Need.\nUse this option if you want this item."] = "Нужен.\nИспользуйте данный выбор, если вам необходим этот предмет."
	L["Mousewheel up/Left Click - Increase bid.\nMousewheel down/Right Click - decrease bid.\nSHIFT-KEY - change bid by +/-1\nALT-KEY - change bid by +/-20"] = "Mousewheel up/Left Click - Увеличить стоимость.\nMousewheel down/Right Click - Уменьшить стоимость.\nSHIFT-KEY - Изменить стоимость на +/-1\nALT-KEY - Изменить стоимость на +/-20"
	L["Take.\nUse this option if you are able to take this\nitem, but do not necessarily want it or\nwould prefer someone else take it first.\nAlternatively use this button if this is an\noff-spec item (for example dps gear for\nhealers) \nor you have ALREADY received loot.\nBidWar mode use this button to place bid."] = "Возьму.\nИспользуйте данный выбор, если вы в состоянии взять\nданный предмет, но не нуждаетесь в нем и согласны\nуступить тому кто в нем нуждается больше.\nТак же используйте данный выбор если он указан\nкак для альтернативного билда (например дпс для\nцелителей)\nили вы уже получили лут.\n В BidWar моде для размещения заявки."
	L["Pass.\nUse this option if you do not need this item"] = "Пас.\nИспользуйте данный выбор, если вы не нуждаетесь в этом предмете."
end

local L = LibStub("AceLocale-3.0"):GetLocale("MorgBid2")

local bid = { }
local bidstep = 5
local BIDWAR
local db
local dkp = 0
local frames = { }
local origbid = { }
local overbid = 0
local Player = UnitName("player")
local version = tonumber(GetAddOnMetadata("MorgBid2", "Version")) 
	
local Quality = {[1] = {.6, .6, .6},
		[2] =  {1, 1, 1},
		[3] = {0, 1, 0},
		[4] = {0, .5, 1},
		[5] = {.7, .46, 1},
		[6] = {1, .5, 0},
		[7] = {.9, .8, .5}
}
	
local defaults = { 
	profile = {
		point = "CENTER",
		relpoint = "CENTER",
		x = 0,
		y = 0,
		anchorpoint = "CENTER",
		anchorrelpoint = "CENTER",
		anchorx = 0,
		anchory = 0,
		hints = true,
		result = true,
		resultheight = 35,
		media = {
    			font = "Friz Quadrata TT",
    			fontsize = 7,
    			border = "Blizzard Tooltip",
	    		background = "Blizzard Out of Control",
			backdropC = { .58, .58, .58, 1},
			borderC = { .96, .93, .26, .75 },
			resultfont = "Friz Quadrata TT",
    			resultfontsize = 7,
    		},
	},
}

local options = {
		type = "group",
		handler = MorgBid2,
		name = L["MorgBid2"],
		desc = L["MorgBid2"],
		args = {
			head = {
				type = "header",
				name = L["General options"] .. " v" .. version,
				order = 10
			},
			showhints = {
				type = "toggle",
				name = L["Hide hints"],
				desc = L["Disables the tooltip hints."],
				get = function() return MorgBid2.db.profile.hints end,
				set = function(info, v) MorgBid2.db.profile.hints = v end,
				order = 20
			},
			resulttt = {
				type = "toggle",
				name = L["Use result tooltip"],
				desc = L["Shows the DKP listing of the current item after the auction ends."],
				get = function() return MorgBid2.db.profile.result end,
				set = function(info, v) MorgBid2.db.profile.result = v end,
				order = 30
			},
			reset = {
				type = "execute",
				name = L["Reset frames"],
				desc = L["Reset default frame positions."],
				func = function() MorgBid2:ResetFrames() end,
				order = 40
			},
			head1 = {
				type = "header",
				name = L["All frames"],
				order = 100
			},
			background = {
				type = "select",
				dialogControl = "LSM30_Background",
				name = L["Background texture"],
				desc = L["Background texture"],
				get = function() return MorgBid2.db.profile.media.background end,
				set = function(info, v) 
						MorgBid2.db.profile.media.background = v
						MorgBid2:UpdateFrameMedia()
					end,
				values = AceGUIWidgetLSMlists.background, 
				order = 110
			},
			border = {
				type = "select",
				dialogControl = "LSM30_Border",
				name = L["Border texture"],
				desc = L["Border texture"],
				get = function() return MorgBid2.db.profile.media.border end,
				set = function(info, v) 
						MorgBid2.db.profile.media.border = v
						MorgBid2:UpdateFrameMedia()
					end,
				values = AceGUIWidgetLSMlists.border, 
				order = 120
			},
			space = {
				type = "description",
				name = "",
				order = 125
			},
			backdropC = {
				type = "color",
				name = L["Background color"],
				hasAlpha = true,
				set = "SetColorOpt",
				get = "GetColorOpt",
				order = 130
			},
			borderC = {
				type = "color",
				name = L["Border color"],
				hasAlpha = true,
				set = "SetColorOpt",
				get = "GetColorOpt",
				order = 140
			},
			head2 = {
				type = "header",
				name = L["Bidding tooltip options"],
				order = 200
			},
			font = {
		 		type = "select",
		 		dialogControl = "LSM30_Font",
		 		name = L["Font"],
		 		desc = L["Font"],
		 		get = function() return MorgBid2.db.profile.media.font end,
		 		set = function(info, v) MorgBid2.db.profile.media.font = v MorgBid2:UpdateFrameMedia() end,
		 		values = AceGUIWidgetLSMlists.font, 
				order = 210
			},
			fontsize = {
				type = "range",
				name = L["Font size"],
				get = function() return MorgBid2.db.profile.media.fontsize end,
				set = function(info, v) MorgBid2.db.profile.media.fontsize = v MorgBid2:UpdateFrameMedia() end,
				min = 1, 
				max = 30, 
				step = 1,
				order = 220
			},
			head3 = {
				type = "header",
				name = L["Result Frame options"],
				hidden = function() return not MorgBid2.db.profile.result end,
				order = 300
			},
			resultfont = {
		 		type = "select",
		 		dialogControl = "LSM30_Font",
		 		name = L["Result Font"],
		 		get = function() return MorgBid2.db.profile.media.resultfont end,
		 		set = function(info, v) MorgBid2.db.profile.media.resultfont = v MorgBid2:UpdateResultMedia() end,
		 		values = AceGUIWidgetLSMlists.font, 
		 		hidden = function() return not MorgBid2.db.profile.result end,
				order = 310
			},
			resultfontsize = {
				type = "range",
				name = L["Result fontsize"],
				get = function() return MorgBid2.db.profile.media.resultfontsize end,
				set = function(info, v) MorgBid2.db.profile.media.resultfontsize = v MorgBid2:UpdateResultMedia() end,
				min = 1, 
				max = 30, 
				step = 1,
				hidden = function() return not MorgBid2.db.profile.result end,
				order = 320
			},
			resultmaxheight = {
				type = "range",
				name = L["Result lines"],
				desc = L["Maximum number of lines before creating a scrollframe."],
				get = function() return MorgBid2.db.profile.resultheight end,
				set = function(info, v) MorgBid2.db.profile.resultheight = v MorgBid2:UpdateResultMedia() end,
				min = 10, 
				max = 100, 
				step = 1,
				hidden = function() return not MorgBid2.db.profile.result end,
				order = 330
			},
		},
}


function MorgBid2:OnInitialize()
	--saved variables and config options
	self.db = LibStub("AceDB-3.0"):New("MorgBid2DB", defaults, "Default")
		
	LibStub("AceConfig-3.0"):RegisterOptionsTable("MorgBid2", options)
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("MorgBid2", "MorgBid2")
	
	self:RegisterChatCommand("morgbid2", "ChatCommand")
	
end

function MorgBid2:OnEnable()
	self:RegisterComm("MorgBid2", "OnCommReceive")
	db = self.db.profile
	
end

function MorgBid2:OnDisable()
	
end

function MorgBid2:ChatCommand(arg1)
	--handle chat command being non blank
	if not arg1 or arg1 == "" then 
		if not C.OpenFrames["MorgBid2"] then C:Open("MorgBid2") 
		else C:Close("MorgBid2") end
	else CC:HandleCommand("MorgBid2", "MorgBid2", arg1:trim() ~= "help" and arg1 or "")
	end
end

function MorgBid2:SetColorOpt(info, r, g, b, a)
	local db = self.db.profile.media
	local opt = info[#info]
	db[opt][1] = r
	db[opt][2] = g
	db[opt][3] = b
	db[opt][4] = a
	self:UpdateFrameMedia()
end

function MorgBid2:GetColorOpt(info)
	local opt = info[#info]
	return unpack(self.db.profile.media[opt])
end

function MorgBid2:UpdateFrameMedia()
	if not frames[1] then self:AddItemDialog(30988, 50, 500) end
	frames[1].frame:Show()
	for _, data in pairs(frames) do
		self:CreateBackdrop(data.frame)
		self:UpdateFrameDimensions(data.frame)
	end
end

function MorgBid2:UpdateResultMedia()
	local dkp = {}
	for i = 1, 80, 2 do
		dkp[i] = {{n = "Test", r = 1, g = 1, b = 1}, {n = "NEED", r = 0, g = 1, b = 0}, {n = 500, r = 0, g = 1, b = 0}}
		dkp[i+1] = {{n = "NotaTest", r = 1, g = 1, b = 1}, {n = "PASS", r = 1, g = 0, b = 0}, {n = 50, r = 1, g = 1, b = 0}}
	end
	if not self.anchor then
		self:CreateResultFrame()
		self:CreateBackdrop(self.anchor)
	end
	self:UpdateResultFrame(self.anchor, dkp, true)
	self.anchor:Show()
end

function MorgBid2:CreateBackdrop(f)
	local db = self.db.profile
	local backdrop = f:GetBackdrop()
	if not backdrop then
		backdrop = {
			insets = {left = 3, right = 3, top = 3, bottom = 3},
			tile = false, 
			tileSize = 16, 
			edgeSize = 8,
		}
	end
	backdrop.edgeFile = media:Fetch("border", db.media.border)
	backdrop.bgFile = media:Fetch("background", db.media.background)
	f:SetBackdrop(backdrop)
	f:SetBackdropColor(unpack(db.media.backdropC))
   	f:SetBackdropBorderColor(unpack(db.media.borderC))
end

function MorgBid2:UpdateFrameDimensions(f)
	local font = media:Fetch("font", db.media.font)
	f.name:SetFont(font, db.media.fontsize + 2)
   	f.subname:SetFont(font, db.media.fontsize) 
   	f.dkp:SetFont(font, db.media.fontsize + 2) 
   	f.icon:SetWidth(26 + db.media.fontsize)
	f.icon:SetHeight(26 + db.media.fontsize)
	local width = 200 + ((db.media.fontsize - 9) * 9)
	f:SetWidth(width) 
	f.name:SetWidth(width - 42 - db.media.fontsize)
   	f:SetHeight(75 + ((db.media.fontsize - 9) * 2))
   	if f.bidbutton then f.bidbutton.text:SetFont(font, db.media.fontsize + 1) end
end

function MorgBid2:ResetFrames()
	db.point = "CENTER"
	db.relpoint = "CENTER"
	db.x = 0
	db.y = 0
	db.anchorpoint = "CENTER"
	db.anchorrelpoint = "CENTER"
	db.anchorx = 0
	db.anchory = 0
	
	local f = self.anchor
	f:ClearAllPoints()
   	local point, relpoint, x, y = db.anchorpoint, db.anchorrelpoint, db.anchorx, db.anchory
	f:SetPoint(point, UIParent, relpoint, x, y)
end

function MorgBid2:CreateResultFrame()
	if self.anchor then return end
	local font = media:Fetch("font", db.media.resultfont)
	local edge = media:Fetch("border", db.media.border)
	local bg = media:Fetch("background", db.media.background)
	local fontsize = db.media.resultfontsize
	
	f = CreateFrame("Frame", nil)
	f.textid = 1
	f.textlen = 0
	f.height = 0
	f.text = {}
	f:SetFrameStrata("DIALOG")
   	f:SetFrameLevel(5)
   	f:EnableMouse(1)
   	f:SetMovable(1)
   	f:SetResizable(1)
   	f:RegisterForDrag("LeftButton")
   	f:ClearAllPoints()
   	local point, relpoint, x, y = db.anchorpoint, db.anchorrelpoint, db.anchorx, db.anchory
	f:SetPoint(point, UIParent, relpoint, x, y)
  	
  	f:SetScript("OnDragStart", function(f) f:StartMoving() end) 
  	f:SetScript("OnDragStop", function(f)
   						f:StopMovingOrSizing()
   						local point, _, relativePoint, x, y = f:GetPoint()
						db.anchorpoint = point
						db.anchorrelpoint = relativePoint
						db.anchorx = math.floor(x)
						db.anchory = math.floor(y)
   					end) 
  	
  	f.title = f:CreateFontString()
   	f.title:SetPoint("TOP", f, "TOP", 0, -5)
   	f.title:SetJustifyH("CENTER")
   	f.title:SetFont(font, fontsize + 2)
   	f.title:SetTextColor(unpack(db.media.borderC))
   	f.title:SetText("test")
   	f.title:Show()
   	   	
	f.scroll = CreateFrame("ScrollFrame", nil, f)
   	f.scroll:EnableMouse(1)
   	f.scroll:ClearAllPoints()
   	f.scroll:EnableMouseWheel(1)
   	f.scroll:SetPoint("TOP", f.title, "BOTTOM", 0, -5)
   	f.scroll:SetBackdrop({ bgFile = "", tile = false, tileSize = 16, edgeFile = edge, edgeSize = 8, insets = { left = 3, right = 3, top = 3, bottom = 3 } })
	f.scroll:SetBackdropBorderColor(0, 0, 0, 1)
	f.scroll.text = {}
   	f.scroll.textid = 1
	f.scroll.textlen = 0
	f.scroll.height = 0
   	
   	f.close = CreateFrame("Button", nil, f)
   	f.close:SetScript("OnClick", function(f) f:GetParent():Hide() end)
   	f.close:SetWidth(18)
   	f.close:SetHeight(18)
   	f.close:SetNormalTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Up")
   	f.close:SetPushedTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Down")
   	f.close:SetHighlightTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Highlight")
   	f.close:ClearAllPoints()
   	f.close:SetPoint("TOPRIGHT", f, "TOPRIGHT", 0, 0)
   	f.close:SetHitRectInsets(5, 5, 5, 5)
   	f.close:Show()
   	   	
	f:SetBackdrop({ bgFile = bg, tile = false, tileSize = 16, edgeFile = edge, edgeSize = 8, insets = { left = 3, right = 3, top = 3, bottom = 3 } })
	f:SetBackdropColor(unpack(db.media.backdropC))
	f:SetBackdropBorderColor(unpack(db.media.borderC))
	self.anchor = f
end

function MorgBid2:AddTextLine(f, t1, t2, t3)
	local id = f.textid or 1
	local attach, relpoint, top
	local t2width = 0
	local t3width = 0
	local addwidth = 30
	local font = media:Fetch("font", db.media.resultfont) 
	local height = db.media.resultfontsize
	if id == 1 then 
		attach = f
		relpoint = "TOPLEFT"
		if f.title then
			local titleheight = f.title:GetStringHeight() + 5
			top = -titleheight
			f.height = f.height + titleheight
		else top = -5 end	
	else 
		attach = f.text[id-1]
		relpoint = "BOTTOMLEFT"
		top = 0
	end
	
	f.text[id] = CreateFrame("Button", nil, f)
	f.text[id]:SetHighlightTexture("Interface\\QuestFrame\\UI-QuestTitleHighlight")
   	f.text[id]:ClearAllPoints()
   	f.text[id]:SetPoint("TOPLEFT", attach, relpoint, 0 , top)
   	f.text[id]:SetBackdropColor(0, 0, 0, 1)
	f.text[id]:Show()
   	
   	f.text[id].text1 = f.text[id]:CreateFontString()
   	f.text[id].text1:SetPoint("LEFT", f.text[id], "LEFT", 5, 0)
   	f.text[id].text1:SetJustifyH("LEFT")
   	f.text[id].text1:SetFont(font, height)
   	f.text[id].text1:SetTextColor(t1.r, t1.g, t1.b)
   	f.text[id].text1:SetText(t1.n)
   	f.text[id].text1:Show()
   	
   	if t3 then
   		f.text[id].text3 = f.text[id]:CreateFontString()
   		f.text[id].text3:SetPoint("CENTER", f.text[id], "CENTER")
   		f.text[id].text3:SetJustifyH("CENTER")
   		f.text[id].text3:SetFont(font, height)
   		f.text[id].text3:SetTextColor(t3.r, t3.g, t3.b)
   		f.text[id].text3:SetText(t3.n)
   		f.text[id].text3:Show()
   		t3width = f.text[id].text3:GetStringWidth()
   		addwidth = addwidth + 25
   	end
   	
   	f.text[id].text2 = f.text[id]:CreateFontString()
   	f.text[id].text2:SetPoint("RIGHT", f.text[id], "RIGHT")
   	f.text[id].text2:SetJustifyH("RIGHT")
   	f.text[id].text2:SetFont(font, height)
   	f.text[id].text2:SetTextColor(t2.r, t2.g, t2.b)
   	f.text[id].text2:SetText(t2.n)
   	f.text[id].text2:Show()
   	t2width = f.text[id].text2:GetStringWidth()
   	   	
   	local width = f.text[id].text1:GetStringWidth() + t2width + t3width + addwidth
   	if t3width == 0 then width = width + 5 end
   	if width > f.textlen then f.textlen = width end
   	f.textid = f.textid + 1
   	f.height = f.height + height
   	f.text[id]:SetHeight(height)
end

function MorgBid2:Scrollframe_Update(f, numitems, maxitems, data, direction, text3)
	local line
	local lineplusoffset
	local change = 1
	local offset = floor(f:GetVerticalScroll() + 0.5)
	if IsControlKeyDown() then
		if direction == 1 then offset = 0
		elseif direction == -1 then offset = numitems - maxitems end
	else
		if IsShiftKeyDown() then change = 10 end
		if direction == -1 then offset = offset + change
		elseif direction == 1 then offset = offset - change end
	end
	if offset < 0 then offset = 0 
	elseif offset > (numitems - maxitems) then offset = numitems - maxitems end
	f:SetVerticalScroll(offset)
	for line = 1, maxitems do
		lineplusoffset = line + offset
		if lineplusoffset <= numitems then
			local value = data[lineplusoffset]
			f.text[line].text1:SetText(value[1].n)
			f.text[line].text1:SetTextColor(value[1].r, value[1].g, value[1].b)
			if value[3] then
				f.text[line].text2:SetText(value[3].n)
				f.text[line].text2:SetTextColor(value[3].r, value[3].g, value[3].b)
			end
			if text3 then 
				f.text[line].text3:SetText(value[2].n)
				f.text[line].text3:SetTextColor(value[2].r, value[2].g, value[2].b)
			end
			f.text[line]:Show()
		else
			if f.text[line] then f.text[line]:Hide() end
		end
	end
end

function MorgBid2:CreateFrame(itemid, itemlink)
	local font = media:Fetch("font", db.media.font)
	local edge = media:Fetch("border", db.media.border)
	local bg = media:Fetch("background", db.media.background)
	local fontsize = db.media.fontsize
	
	local f = CreateFrame("Button", nil, UIParent)
    	f:EnableMouse(true)
    	f:SetFrameStrata("DIALOG")
    	f:RegisterForClicks("LeftButtonUp", "RightButtonUp", "MiddleButtonUp", "Button4Up", "Button5Up")
    	f:EnableMouseWheel(1)
	f:SetMovable(1)
	f:RegisterForDrag("LeftButton")
   	f:SetScript("OnDragStart", function(f) f:StartMoving() end)
   	f:SetScript("OnDragStop", function(f) 
   					f:StopMovingOrSizing() 
   					local p, t, v, x, y = f:GetPoint()
					db.x = math.floor(x)
					db.y = math.floor(y)
					db.point = p
					db.relpoint = v
			end)
	f:SetID(itemid)
	f.id = itemid
	f.link = itemlink
	
	f.icon = CreateFrame("Button", "MorgBidIcon", f)
	f.icon:SetWidth(26 + fontsize)
	f.icon:SetHeight(26 + fontsize)
	f.icon:ClearAllPoints()
	f.icon:SetPoint("TOPLEFT", f, "TOPLEFT", 5, -5)
	f.icon:SetScript("OnEnter", function(f)
		GameTooltip:SetOwner(f, "ANCHOR_RIGHT")
		GameTooltip:SetHyperlink(f:GetParent().link)
	end)
	f.icon:SetScript("OnLeave", function(f) GameTooltip:Hide() end)
	f.icon:Show()
	
	f.name = f:CreateFontString(nil, "OVERLAY")
	f.name:SetFont(font, fontsize + 2)
	f.name:SetJustifyH("LEFT")
	f.name:SetHeight(20)
	f.name:ClearAllPoints()
	f.name:SetPoint("TOPLEFT", f.icon, "TOPRIGHT", 5, 0)
	
	f.subname = f:CreateFontString(nil, "OVERLAY")
	f.subname:SetFont(font, fontsize)
	f.subname:SetJustifyH("LEFT")
	f.subname:SetWidth(200)
	f.subname:SetHeight(20)
	f.subname:ClearAllPoints()
	f.subname:SetPoint("BOTTOMLEFT", f.icon, "BOTTOMRIGHT", 5, 0)
	
	f.dkp = f:CreateFontString(nil, "OVERLAY")
	f.dkp:SetFont(font, fontsize + 2)
	f.dkp:SetJustifyH("LEFT")
	f.dkp:SetWidth(200)
	f.dkp:SetHeight(20)
	f.dkp:ClearAllPoints()
	f.dkp:SetPoint("BOTTOMLEFT", f, "BOTTOMLEFT", 5, 10)

	f.passbutton = CreateFrame("Button", nil, f)
	f.passbutton:SetWidth(32)
	f.passbutton:SetHeight(32)
	f.passbutton:ClearAllPoints()
	f.passbutton:SetPoint("BOTTOMRIGHT", f, "BOTTOMRIGHT", -5, 4)
	f.passbutton:SetNormalTexture("Interface\\Icons\\INV_Enchant_ShardNexusLarge")
	f.passbutton:SetHighlightTexture("Interface\\Buttons\\UI-GroupLoot-Pass-Highlight")
	f.passbutton:SetScript("OnClick", function(f) self:HandleDialogAction(f:GetParent(), L["PASS"]) end)
	f.passbutton:SetScript("OnEnter", function(f)
		if not db.hints then
			GameTooltip:SetOwner(f, "ANCHOR_RIGHT")
			GameTooltip:SetText(L["Pass.\nUse this option if you do not need this item"])
		end
	end)
	f.passbutton:SetScript("OnLeave", function(f) GameTooltip:Hide() end)
	f.passbutton:Show()

	f.takebutton = CreateFrame("Button", nil, f)
	f.takebutton:SetWidth(32)
	f.takebutton:SetHeight(32)
	f.takebutton:ClearAllPoints()
	f.takebutton:SetPoint("RIGHT", f.passbutton, "LEFT", -10, 0)
	f.takebutton:SetNormalTexture("Interface\\Buttons\\UI-GroupLoot-Coin-Up")
	f.takebutton:SetHighlightTexture("Interface\\Buttons\\UI-GroupLoot-Coin-Highlight")
	f.takebutton:SetScript("OnClick", function(f) self:HandleDialogAction(f:GetParent(), L["TAKE"]) end)
	f.takebutton:SetScript("OnEnter", function(f)
		if not db.hints then
			GameTooltip:SetOwner(f, "ANCHOR_RIGHT")
			GameTooltip:SetText(L["Take.\nUse this option if you are able to take this\nitem, but do not necessarily want it or\nwould prefer someone else take it first.\nAlternatively use this button if this is an\noff-spec item (for example dps gear for\nhealers) \nor you have ALREADY received loot.\nBidWar mode use this button to place bid."])
		end
	end)
	f.takebutton:SetScript("OnLeave", function(f) GameTooltip:Hide() end)
	f.takebutton:Show()
	
	if BIDWAR then
		f.bidbutton = CreateFrame("Button", nil, f)
		f.bidbutton:EnableMouseWheel(1)
		f.bidbutton:SetWidth(32)
		f.bidbutton:SetHeight(32)
		f.bidbutton:ClearAllPoints()
		f.bidbutton:SetPoint("RIGHT", f.takebutton, "LEFT", -10, 0)
		f.bidbutton:SetNormalTexture("Interface\\Buttons\\ButtonHilight-Square")
		f.bidbutton:SetScript("OnMouseWheel", function(f) self:HandleBidWarAction(f:GetParent(), arg1) end)
		f.bidbutton:SetScript("OnMouseUp", function(f) self:HandleBidWarAction(f:GetParent(), arg1) end)
		f.bidbutton:SetScript("OnEnter", function(f)
			if not db.hints then
				GameTooltip:SetOwner(f, "ANCHOR_RIGHT")
				GameTooltip:SetText(L["Mousewheel up/Left Click - Increase bid.\nMousewheel down/Right Click - decrease bid.\nSHIFT-KEY - change bid by +/-1\nALT-KEY - change bid by +/-20"])
			end
		end)
		f.bidbutton:SetScript("OnLeave", function(f) GameTooltip:Hide() end)
		f.bidbutton:Show()
		
		f.bidbutton.text = f.bidbutton:CreateFontString()
   		f.bidbutton.text:SetFont(font, fontsize + 1)
   		f.bidbutton.text:SetTextColor(0,1,0)
		f.bidbutton.text:ClearAllPoints()
		f.bidbutton.text:SetPoint("CENTER", f.bidbutton, "CENTER")
		f.bidbutton.text:SetText(bid[itemid])
	else
		f.needbutton = CreateFrame("Button", nil, f)
		f.needbutton:SetWidth(32)
		f.needbutton:SetHeight(32)
		f.needbutton:ClearAllPoints()
		f.needbutton:SetPoint("RIGHT", f.takebutton, "LEFT", -10, 0)
		f.needbutton:SetNormalTexture("Interface\\Buttons\\UI-GroupLoot-Dice-Up")
		f.needbutton:SetHighlightTexture("Interface\\Buttons\\UI-GroupLoot-Dice-Highlight")
		f.needbutton:SetScript("OnClick", function(f) self:HandleDialogAction(f:GetParent(), L["NEED"]) end)
		f.needbutton:SetScript("OnEnter", function(f)
			if not db.hints then
				GameTooltip:SetOwner(f, "ANCHOR_RIGHT")
				GameTooltip:SetText(L["Need.\nUse this option if you want this item."])
			end
		end)
		f.needbutton:SetScript("OnLeave", function(f) GameTooltip:Hide() end)
		f.needbutton:Show()
	end
	
	f:SetBackdrop({ bgFile = bg, tile = false, tileSize = 16, edgeFile = edge, edgeSize = 16, insets = { left = 3, right = 3, top = 3, bottom = 3 } })
	f:SetBackdropColor(unpack(db.media.backdropC))
	f:SetBackdropBorderColor(unpack(db.media.borderC))
	
	local width = 200 + ((fontsize - 9) * 9)
	f:SetWidth(width) 
	f.name:SetWidth(width - 42 - fontsize)
	f:SetHeight(75 + ((fontsize - 9) * 2))
	f:SetScale(1.2)
	f:ClearAllPoints()
	local point, relpoint, x, y = db.point, db.relpoint, db.x, db.y
	f:SetPoint(point, UIParent, relpoint, x, y)
	table.insert(frames, { frame = f, id = itemid, bidwar = BIDWAR, used = true })
	return f
end

function MorgBid2:AddItemDialog(item, points, memberdkp)
	origbid[item] = points
	bid[item] = points
	local sName, sLink, iQuality, _, iLevel, sType, sSubType, iCount, iLoc, iTexture = GetItemInfo(item)
	
	local f = self:GetFrame(item, sLink)
	f.icon:SetNormalTexture(iTexture)
	f.name:SetText(sName)
	if not iQuality then iQuality = 2 end
	f.name:SetTextColor(unpack(Quality[iQuality + 1]))
	if points then
		f.subname:SetText(points .. L[" points"])
		f.subname:Show()
	else
		f.subname:Hide()
	end
	if memberdkp ~= L["NONE"] then
		dkp = memberdkp
		f.dkp:SetText("|c001eff00"..dkp)
		f.dkp:Show()
	else
		f.dkp:Hide()
	end
	if BIDWAR then
		f.bidbutton.text:SetText(points)
	end
	f:Show()
	self:SortDialogs()
end

function MorgBid2:GetFrame(item, link)
	local found, frame
	for i,v in ipairs(frames) do
		if not v.used and v.bidwar == BIDWAR then 
			frame = v.frame
			v.used = true
			v.id = item
			frame.id = item
			frame.link = link
			found = true
			frame:SetID(item)
			break
		end
	end
	if not found then frame = self:CreateFrame(item, link) end
	return frame
end

function MorgBid2:HandleDialogAction(frame, action)
	local item = frame.id
	self:RemoveFrame(item)
	if item == 20725 then return end
	self:SortDialogs() 
	self:SendCommMessage("MorgDKP2MorgBid", self:Serialize(action, item, bid[item]), "RAID")
	--DEFAULT_CHAT_FRAME:AddMessage("MorgBid2 Action: "..action.." on item "..item.." "..bid[item])
end

function MorgBid2:RemoveFrame(itemid)
	for i,v in pairs(frames) do
		if v.id == itemid then 
			v.frame:Hide()
			v.used = nil
			break
		end
	end
	self:SortDialogs()
end

function MorgBid2:SortDialogs()
	local ct = 0
	for i,v in pairs(frames) do
		if v.used then
			v.frame:ClearAllPoints()
			v.frame:SetPoint(db.point, UIParent, db.relpoint, db.x, db.y + ct*80)
			ct = ct + 1
		end
	end
end

function MorgBid2:OnCommReceive(prefix, message, distribution, sender)
	local result, command, item, points, target, playerdkp, step, obid = self:Deserialize(message)
	if not result then return end
	if command == "QUERY" then
		BIDWAR = nil
		if target == Player then self:AddItemDialog(item, points, playerdkp) end 
	elseif command == "CHECK" then
    		self:SendCommMessage("MorgDKP2MorgBid", self:Serialize("REPLY", Player, version), "RAID")
    	elseif command == "BIDWAR" then
		BIDWAR = true
		bidstep = step
		overbid = obid
		if target == Player then self:HandleBidwarAction(item, points, playerdkp) end
	elseif command == "CLOSE" then self:RemoveFrame(item) 
	elseif command == "INITIATE" and item == Player then self:InitiateTransfer()
	elseif command == "DKPL" and item == Player then self:FormatDKPTT(command, points, target)
	elseif command == "BIDS" then self:FormatDKPTT(command, points, item, target)
	end
end

function MorgBid2:HandleBidwarAction(item, points, playerdkp)
	local found
	for i,v in pairs(frames) do
		if v.used and v.id == item then
			v.frame.bidbutton.text:SetText(points)
			found = true
		end
	end
	if not found then self:AddItemDialog(item, points, playerdkp) end
end

function MorgBid2:HandleBidWarAction(frame, button)
	local id = frame:GetID()
	local origbidstep = bidstep
	local tempbid = bid[id]
	local maxbid = dkp + overbid
	if IsShiftKeyDown() then bidstep = 1 end
	if IsAltKeyDown() then bidstep = 20 end
	if button == 1 then tempbid = tempbid + bidstep 
	elseif button == -1 then tempbid = tempbid - bidstep 
	elseif button == "LeftButton" then tempbid = tempbid + bidstep 
	elseif button == "RightButton" then tempbid = tempbid - bidstep 
	end
	if tempbid < origbid[id] then tempbid = origbid[id] end
	if tempbid > maxbid then tempbid = maxbid end
	frame.bidbutton.text:SetText(tempbid)
	bid[id] = tempbid
	bidstep = origbidstep
end

function MorgBid2:InitiateTransfer()
	if not self.anchor then self:CreateResultFrame() 
	else 
		local sf = self.anchor.scroll
		for v = 1, sf.textid-1 do
    			sf.text[v]:Hide()
    		end
    		sf:Hide()
		sf.textid = 1
		sf.textlen = 0
		sf.height = 0
	end
	local f = self.anchor
	f.title:SetText(L["Receiving DKP data..."])
	f:SetWidth(160)
	f:SetHeight(35)
	f:Show()
end

function MorgBid2:FormatDKPTT(command, dkp, title, quality)
	if not self.anchor then self:CreateResultFrame() end
	local f = self.anchor
	if command == "BIDS" then
		if not self.db.profile.result then return end
		local needed
		for i, v in ipairs(dkp) do
			if v[1].n == Player then
				needed = true
				break
			end
		end
		if needed then
			f.title:SetText(title)
			f.title:SetTextColor(unpack(Quality[quality + 1]))
			self:UpdateResultFrame(f, dkp, true)
			f:Show()
		end
	else
		f.title:SetText(string.format(L["%s DKP"], title))
		f.title:SetTextColor(unpack(db.media.borderC))
		self:UpdateResultFrame(f, dkp)
		f:Show()
	end
	dkp = nil
	dkplist = nil			
end

function MorgBid2:UpdateResultFrame(f, dkp, text3)
	local maxitems = db.resultheight
	local sf = f.scroll
	
	--clear frame
	for v = 1, sf.textid-1 do
    		sf.text[v]:Hide()
    	end
	sf.textid = 1
	sf.textlen = 0
	sf.height = 0
	
	--populate frame
	local sr, sg, sb = 1, 1, 1
	local numitems = #dkp
	if numitems < maxitems then 
		maxitems = numitems 
		sr, sg, sb = 0, 0, 0
	end
	for i = 1, numitems do
		local data = dkp[i]
		if not text3 then 
			data[3] = data[2]
			data[2] = nil
		end
		self:AddTextLine(sf, data[1], data[3], data[2])
		if i == maxitems then break end
	end
	
	--position frame
	local lineheight = sf.text[1]:GetHeight()
	local width = sf.textlen + db.media.fontsize + 10
	local height = lineheight * maxitems + 10
	sf:SetHeight(height)
	sf:SetWidth(width + 5)
	sf:SetBackdropBorderColor(sr, sg, sb, 1)
	sf:Show()
	f:SetWidth(width + 35)
	f:SetHeight(height + f.title:GetHeight() + 30)
	for v = 1, sf.textid-1 do
    		sf.text[v]:SetWidth(width)
    	end
	
	--update frame
	sf:SetScript("OnMouseWheel", function(f, direction) self:Scrollframe_Update(f, numitems, maxitems, dkp, direction, text3) end)
	self:Scrollframe_Update(sf, numitems, maxitems, dkp, nil, text3)
end
